package main

import (
	"context"
	"fmt"
	"os"
	"os/signal"

	"nikos.codes/prymn/prymn/goagent/pkg/gophx"
)

func main() {
	ctx, cancel := context.WithCancel(context.Background())
	defer cancel()

	socket, err := gophx.Connect(ctx)
	if err != nil {
		fmt.Println(err)
	}

	channel := gophx.NewChannel("agents:1", nil, socket)

	channel.On("foo_bar", func(payload any) {
		fmt.Println("received msg: ", payload)
	})

	handleSignals(cancel)
}

func handleSignals(cancel context.CancelFunc) {
	signalCh := make(chan os.Signal, 1)
	signal.Notify(signalCh)
	<-signalCh
	cancel()
}
